/*****************************************************************
 *
 *  Copyright (c) NEC America, Inc. 2000-2005
 *  All Rights Reserved
 *
 *  No part of this program may be photocopied, reproduced, or
 *  translated to another programming language without the prior
 *  written consent of NEC America, Inc.
 *
 *****************************************************************/

import com.nec.tdd.tools.dbMapper.*;
import com.nec.tdd.tools.logger.Logger;


public class Test {
   public static void main (String[] args) {
      try {
         Test testSuite = new Test();
         testSuite.test(args[0]);
      }
      catch (Exception e) {
         Logger.error ("Error details: ", e);
      }
   }


   void test(String mapperFile) throws Exception {
      DBModule dbm = DBModule.init (mapperFile);
      // Create database interface objects with different types of data-source
      DBInterface poolDBIf = dbm.createDefaultMapper ("pool");
      DBInterface basicDBIf = dbm.createDefaultMapper ("basic");
      DBInterface customDBIf = dbm.createDefaultMapper ("custom");

      // perform very basic test on get and release connections
      testDBIf (poolDBIf, "pool");
      testDBIf (basicDBIf, "basic");
      testDBIf (customDBIf, "custom");
   }

   void testDBIf (DBInterface dbIf, String ifName) throws Exception {
      DBConnection[] connections = new DBConnection[4];
      long startTime = System.currentTimeMillis();

      for (int i=0; i < 100; i++) {
         for (int j=0; j < connections.length; j++) {
            connections[j] = dbIf.getConnection();
         }
         for (int j=0; j < connections.length; j++) {
            dbIf.releaseConnection (connections[j]);
         }
      }

      Logger.debug ("ifName[" + ifName + "] time in ms = "
                   + (System.currentTimeMillis()-startTime));
   }
}

