import java.util.*;
import com.nec.tdd.tools.dbMapper.*;
import com.nec.tdd.tools.logger.Logger;


public class Test {

   DBInterface mapper; // mapper used for this test

   Test (String mapperFile) {

      // create the mapper to be used for this test
      try {
         DBModule dbm = DBModule.init (mapperFile);
         mapper = dbm.createDefaultMapper ("default");
         Logger.debug (mapper.toString());
      }
      catch (Exception e) {
         Logger.error ("Error details: ", e);
         System.exit(0);
      }
      this.mapper = mapper;
   }

   public static void main (String[] args) {
      try {
         String mapperFile = args[0];
         Test testSuite = new Test(mapperFile);
         testSuite.test();
      }
      catch (Exception e) {
         Logger.error ("Error details: ", e);
      }
   }

   void test() throws Exception {
      // Delete older entries
      mapper.deleteAll (Account.class);

      Account p1 = new Account (new Integer(1), new Balance(1, (float) 430.35));
      mapper.createTree (p1);
      Logger.debug ("create(Object) :: Object " + p1
                   + " is successfully created.");

      Account p1Dup = (Account) mapper.findByPrimaryKey (new Integer(1),
                                                            Account.class, 3);
      Logger.debug ("findByPrimaryKey() :: Object " + p1Dup
                   + " is successfully executed.");
   }

}

